using Godot;
using System;
using System.Collections;
using System.Collections.Generic;

public class TileTypeCollection : Resource, IReadOnlyList<TileType>
{
    [Export]
    private List<Resource> _tileTypeResources = new List<Resource>();

    private List<TileType> TileTypes
    {
        get
        {
            if (_tileTypes != null)
                return _tileTypes;

            _tileTypes = new List<TileType>();

            foreach (var resource in _tileTypeResources)
            {
                if (!(resource is TileType))
                    throw new InvalidCastException($"{resource} must be a {typeof(TileType)}");

                _tileTypes.Add((TileType)resource);
            }

            return _tileTypes;
        }
    }
    private List<TileType> _tileTypes = null;

    public TileType this[int index] => TileTypes[index];

    public int Count => TileTypes.Count;

    public IEnumerator<TileType> GetEnumerator()
    {
        return TileTypes.GetEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return TileTypes.GetEnumerator();
    }
}
